=== modified file 'ChangeLog'
--- ChangeLog	2006-07-20 14:31:08 +0000
+++ ChangeLog	2006-07-21 18:18:20 +0000
@@ -1,3 +1,14 @@
+2006-07-21  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
+
+    * olive/olive.glade: some UI refreshment (push, remove and commit dialog)
+    * olive/frontend/gtk/push.py: implemented 'push' functionality
+    * olive/frontend/gtk/commit.py: implemented 'commit' functionality
+    * olive/frontend/gtk/remove.py: implemented 'remove' functionality
+    * olive/frontend/gtk/add.py: implemented 'add' functionality
+    * olive/frontend/gtk/handler.py: implemented 'init' functionality
+    * olive/backend/fileops.py: added recursive mode to add(), added
+      NotBranchError exception to add() and remove()
+
 2006-07-20  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
 
     * olive/frontend/gtk/__init__.py: implemented OliveCommunication.refresh_right()

=== modified file 'olive.glade'
--- olive.glade	2006-07-20 14:31:08 +0000
+++ olive.glade	2006-07-21 18:18:20 +0000
@@ -44,6 +44,54 @@
 		<widget class="GtkMenu" id="menuitem_file_menu">
 
 		  <child>
+		    <widget class="GtkImageMenuItem" id="menuitem_add_files">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">_Add file(s)...</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_menuitem_add_files_activate" last_modification_time="Fri, 21 Jul 2006 11:38:39 GMT"/>
+
+		      <child internal-child="image">
+			<widget class="GtkImage" id="image44">
+			  <property name="visible">True</property>
+			  <property name="stock">gtk-add</property>
+			  <property name="icon_size">1</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			</widget>
+		      </child>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkImageMenuItem" id="menuitem_remove_file">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">Remove file(s)...</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_menuitem_remove_file_activate" last_modification_time="Fri, 21 Jul 2006 13:54:07 GMT"/>
+
+		      <child internal-child="image">
+			<widget class="GtkImage" id="image45">
+			  <property name="visible">True</property>
+			  <property name="stock">gtk-remove</property>
+			  <property name="icon_size">1</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			</widget>
+		      </child>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkSeparatorMenuItem" id="separator_file3">
+		      <property name="visible">True</property>
+		    </widget>
+		  </child>
+
+		  <child>
 		    <widget class="GtkMenuItem" id="menuitem_file_make_directory">
 		      <property name="visible">True</property>
 		      <property name="label" translatable="yes">Make _directory...</property>
@@ -136,7 +184,7 @@
 		      <signal name="activate" handler="on_menuitem_branch_pull_activate" last_modification_time="Mon, 17 Jul 2006 08:52:48 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image10">
+			<widget class="GtkImage" id="image46">
 			  <property name="visible">True</property>
 			  <property name="stock">gtk-goto-bottom</property>
 			  <property name="icon_size">1</property>
@@ -157,7 +205,7 @@
 		      <signal name="activate" handler="on_menuitem_branch_push_activate" last_modification_time="Mon, 17 Jul 2006 08:52:48 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image11">
+			<widget class="GtkImage" id="image47">
 			  <property name="visible">True</property>
 			  <property name="stock">gtk-goto-top</property>
 			  <property name="icon_size">1</property>
@@ -184,7 +232,7 @@
 		      <signal name="activate" handler="on_menuitem_branch_commit_activate" last_modification_time="Mon, 17 Jul 2006 08:53:37 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image12">
+			<widget class="GtkImage" id="image48">
 			  <property name="visible">True</property>
 			  <property name="stock">gtk-redo</property>
 			  <property name="icon_size">1</property>
@@ -461,6 +509,8 @@
 </widget>
 
 <widget class="GtkWindow" id="window_commit">
+  <property name="width_request">400</property>
+  <property name="height_request">400</property>
   <property name="title" translatable="yes">Olive - Commit</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
@@ -470,7 +520,7 @@
   <property name="decorated">True</property>
   <property name="skip_taskbar_hint">False</property>
   <property name="skip_pager_hint">False</property>
-  <property name="type_hint">GDK_WINDOW_TYPE_HINT_NORMAL</property>
+  <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
@@ -544,6 +594,63 @@
       </child>
 
       <child>
+	<widget class="GtkCheckButton" id="checkbutton_commit_local">
+	  <property name="visible">True</property>
+	  <property name="can_focus">True</property>
+	  <property name="label" translatable="yes">_Local only commit (works in bound branches)</property>
+	  <property name="use_underline">True</property>
+	  <property name="relief">GTK_RELIEF_NORMAL</property>
+	  <property name="focus_on_click">True</property>
+	  <property name="active">False</property>
+	  <property name="inconsistent">False</property>
+	  <property name="draw_indicator">True</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkCheckButton" id="checkbutton_commit_strict">
+	  <property name="visible">True</property>
+	  <property name="can_focus">True</property>
+	  <property name="label" translatable="yes">_Strict commit (fails if unknown files available)</property>
+	  <property name="use_underline">True</property>
+	  <property name="relief">GTK_RELIEF_NORMAL</property>
+	  <property name="focus_on_click">True</property>
+	  <property name="active">False</property>
+	  <property name="inconsistent">False</property>
+	  <property name="draw_indicator">True</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkCheckButton" id="checkbutton_commit_force">
+	  <property name="visible">True</property>
+	  <property name="can_focus">True</property>
+	  <property name="label" translatable="yes">_Force commit (even do it when nothing has changed)</property>
+	  <property name="use_underline">True</property>
+	  <property name="relief">GTK_RELIEF_NORMAL</property>
+	  <property name="focus_on_click">True</property>
+	  <property name="active">False</property>
+	  <property name="inconsistent">False</property>
+	  <property name="draw_indicator">True</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
 	<widget class="GtkHButtonBox" id="hbuttonbox_commit">
 	  <property name="visible">True</property>
 	  <property name="layout_style">GTK_BUTTONBOX_SPREAD</property>
@@ -556,9 +663,10 @@
 	      <property name="can_focus">True</property>
 	      <property name="relief">GTK_RELIEF_NORMAL</property>
 	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_commit_commit_clicked" last_modification_time="Fri, 21 Jul 2006 15:04:57 GMT"/>
 
 	      <child>
-		<widget class="GtkAlignment" id="alignment1">
+		<widget class="GtkAlignment" id="alignment5">
 		  <property name="visible">True</property>
 		  <property name="xalign">0.5</property>
 		  <property name="yalign">0.5</property>
@@ -570,15 +678,15 @@
 		  <property name="right_padding">0</property>
 
 		  <child>
-		    <widget class="GtkHBox" id="hbox3">
+		    <widget class="GtkHBox" id="hbox7">
 		      <property name="visible">True</property>
 		      <property name="homogeneous">False</property>
 		      <property name="spacing">2</property>
 
 		      <child>
-			<widget class="GtkImage" id="image1">
+			<widget class="GtkImage" id="image49">
 			  <property name="visible">True</property>
-			  <property name="stock">gtk-apply</property>
+			  <property name="stock">gtk-redo</property>
 			  <property name="icon_size">4</property>
 			  <property name="xalign">0.5</property>
 			  <property name="yalign">0.5</property>
@@ -593,9 +701,9 @@
 		      </child>
 
 		      <child>
-			<widget class="GtkLabel" id="label2">
+			<widget class="GtkLabel" id="label11">
 			  <property name="visible">True</property>
-			  <property name="label" translatable="yes">Commit</property>
+			  <property name="label" translatable="yes">_Commit</property>
 			  <property name="use_underline">True</property>
 			  <property name="use_markup">False</property>
 			  <property name="justify">GTK_JUSTIFY_LEFT</property>
@@ -632,13 +740,14 @@
 	      <property name="use_stock">True</property>
 	      <property name="relief">GTK_RELIEF_NORMAL</property>
 	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_commit_cancel_clicked" last_modification_time="Fri, 21 Jul 2006 15:04:52 GMT"/>
 	    </widget>
 	  </child>
 	</widget>
 	<packing>
 	  <property name="padding">0</property>
 	  <property name="expand">False</property>
-	  <property name="fill">False</property>
+	  <property name="fill">True</property>
 	</packing>
       </child>
     </widget>
@@ -989,4 +1098,627 @@
   <property name="translator_credits" translatable="yes" comments="TRANSLATORS: Replace this string with your names, one name per line.">translator-credits</property>
 </widget>
 
+<widget class="GtkWindow" id="window_add">
+  <property name="visible">True</property>
+  <property name="title" translatable="yes">Olive - Add file(s)</property>
+  <property name="type">GTK_WINDOW_TOPLEVEL</property>
+  <property name="window_position">GTK_WIN_POS_NONE</property>
+  <property name="modal">False</property>
+  <property name="resizable">False</property>
+  <property name="destroy_with_parent">False</property>
+  <property name="decorated">True</property>
+  <property name="skip_taskbar_hint">False</property>
+  <property name="skip_pager_hint">False</property>
+  <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
+  <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
+  <property name="focus_on_map">True</property>
+  <property name="urgency_hint">False</property>
+
+  <child>
+    <widget class="GtkVBox" id="vbox_add">
+      <property name="border_width">5</property>
+      <property name="visible">True</property>
+      <property name="homogeneous">False</property>
+      <property name="spacing">3</property>
+
+      <child>
+	<widget class="GtkLabel" id="label_add_question">
+	  <property name="visible">True</property>
+	  <property name="label" translatable="yes">Which file(s) do you want to add?</property>
+	  <property name="use_underline">False</property>
+	  <property name="use_markup">False</property>
+	  <property name="justify">GTK_JUSTIFY_LEFT</property>
+	  <property name="wrap">False</property>
+	  <property name="selectable">False</property>
+	  <property name="xalign">0.5</property>
+	  <property name="yalign">0.5</property>
+	  <property name="xpad">0</property>
+	  <property name="ypad">0</property>
+	  <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+	  <property name="width_chars">-1</property>
+	  <property name="single_line_mode">False</property>
+	  <property name="angle">0</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkRadioButton" id="radiobutton_add_selected">
+	  <property name="visible">True</property>
+	  <property name="can_focus">True</property>
+	  <property name="label" translatable="yes">Selected only</property>
+	  <property name="use_underline">True</property>
+	  <property name="relief">GTK_RELIEF_NORMAL</property>
+	  <property name="focus_on_click">True</property>
+	  <property name="active">False</property>
+	  <property name="inconsistent">False</property>
+	  <property name="draw_indicator">True</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkRadioButton" id="radiobutton_add_unknown">
+	  <property name="visible">True</property>
+	  <property name="can_focus">True</property>
+	  <property name="label" translatable="yes">All unknowns recursively</property>
+	  <property name="use_underline">True</property>
+	  <property name="relief">GTK_RELIEF_NORMAL</property>
+	  <property name="focus_on_click">True</property>
+	  <property name="active">False</property>
+	  <property name="inconsistent">False</property>
+	  <property name="draw_indicator">True</property>
+	  <property name="group">radiobutton_add_selected</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkHButtonBox" id="hbuttonbox_add">
+	  <property name="visible">True</property>
+	  <property name="layout_style">GTK_BUTTONBOX_DEFAULT_STYLE</property>
+	  <property name="spacing">0</property>
+
+	  <child>
+	    <widget class="GtkButton" id="button_add_add">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_add_add_clicked" last_modification_time="Fri, 21 Jul 2006 11:37:11 GMT"/>
+
+	      <child>
+		<widget class="GtkAlignment" id="alignment3">
+		  <property name="visible">True</property>
+		  <property name="xalign">0.5</property>
+		  <property name="yalign">0.5</property>
+		  <property name="xscale">0</property>
+		  <property name="yscale">0</property>
+		  <property name="top_padding">0</property>
+		  <property name="bottom_padding">0</property>
+		  <property name="left_padding">0</property>
+		  <property name="right_padding">0</property>
+
+		  <child>
+		    <widget class="GtkHBox" id="hbox5">
+		      <property name="visible">True</property>
+		      <property name="homogeneous">False</property>
+		      <property name="spacing">2</property>
+
+		      <child>
+			<widget class="GtkImage" id="image13">
+			  <property name="visible">True</property>
+			  <property name="stock">gtk-add</property>
+			  <property name="icon_size">4</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			</widget>
+			<packing>
+			  <property name="padding">0</property>
+			  <property name="expand">False</property>
+			  <property name="fill">False</property>
+			</packing>
+		      </child>
+
+		      <child>
+			<widget class="GtkLabel" id="label8">
+			  <property name="visible">True</property>
+			  <property name="label" translatable="yes">_Add</property>
+			  <property name="use_underline">True</property>
+			  <property name="use_markup">False</property>
+			  <property name="justify">GTK_JUSTIFY_LEFT</property>
+			  <property name="wrap">False</property>
+			  <property name="selectable">False</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			  <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+			  <property name="width_chars">-1</property>
+			  <property name="single_line_mode">False</property>
+			  <property name="angle">0</property>
+			</widget>
+			<packing>
+			  <property name="padding">0</property>
+			  <property name="expand">False</property>
+			  <property name="fill">False</property>
+			</packing>
+		      </child>
+		    </widget>
+		  </child>
+		</widget>
+	      </child>
+	    </widget>
+	  </child>
+
+	  <child>
+	    <widget class="GtkButton" id="button_add_cancel">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="label">gtk-cancel</property>
+	      <property name="use_stock">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_add_cancel_clicked" last_modification_time="Fri, 21 Jul 2006 11:37:02 GMT"/>
+	    </widget>
+	  </child>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">True</property>
+	  <property name="fill">True</property>
+	</packing>
+      </child>
+    </widget>
+  </child>
+</widget>
+
+<widget class="GtkWindow" id="window_remove">
+  <property name="visible">True</property>
+  <property name="title" translatable="yes">Olive - Remove file(s)</property>
+  <property name="type">GTK_WINDOW_TOPLEVEL</property>
+  <property name="window_position">GTK_WIN_POS_NONE</property>
+  <property name="modal">False</property>
+  <property name="resizable">False</property>
+  <property name="destroy_with_parent">False</property>
+  <property name="decorated">True</property>
+  <property name="skip_taskbar_hint">False</property>
+  <property name="skip_pager_hint">False</property>
+  <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
+  <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
+  <property name="focus_on_map">True</property>
+  <property name="urgency_hint">False</property>
+
+  <child>
+    <widget class="GtkVBox" id="vbox_remove">
+      <property name="border_width">5</property>
+      <property name="visible">True</property>
+      <property name="homogeneous">False</property>
+      <property name="spacing">3</property>
+
+      <child>
+	<widget class="GtkLabel" id="label_remove_question">
+	  <property name="visible">True</property>
+	  <property name="label" translatable="yes">Which file(s) do you want to remove?</property>
+	  <property name="use_underline">False</property>
+	  <property name="use_markup">False</property>
+	  <property name="justify">GTK_JUSTIFY_LEFT</property>
+	  <property name="wrap">False</property>
+	  <property name="selectable">False</property>
+	  <property name="xalign">0.5</property>
+	  <property name="yalign">0.5</property>
+	  <property name="xpad">0</property>
+	  <property name="ypad">0</property>
+	  <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+	  <property name="width_chars">-1</property>
+	  <property name="single_line_mode">False</property>
+	  <property name="angle">0</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkRadioButton" id="radiobutton_remove_selected">
+	  <property name="visible">True</property>
+	  <property name="can_focus">True</property>
+	  <property name="label" translatable="yes">Selected only</property>
+	  <property name="use_underline">True</property>
+	  <property name="relief">GTK_RELIEF_NORMAL</property>
+	  <property name="focus_on_click">True</property>
+	  <property name="active">False</property>
+	  <property name="inconsistent">False</property>
+	  <property name="draw_indicator">True</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkRadioButton" id="radiobutton_remove_new">
+	  <property name="visible">True</property>
+	  <property name="can_focus">True</property>
+	  <property name="label" translatable="yes">All files with status 'added'</property>
+	  <property name="use_underline">True</property>
+	  <property name="relief">GTK_RELIEF_NORMAL</property>
+	  <property name="focus_on_click">True</property>
+	  <property name="active">False</property>
+	  <property name="inconsistent">False</property>
+	  <property name="draw_indicator">True</property>
+	  <property name="group">radiobutton_remove_selected</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkHButtonBox" id="hbuttonbox_remove">
+	  <property name="visible">True</property>
+	  <property name="layout_style">GTK_BUTTONBOX_DEFAULT_STYLE</property>
+	  <property name="spacing">0</property>
+
+	  <child>
+	    <widget class="GtkButton" id="button_remove_remove">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_remove_remove_clicked" last_modification_time="Fri, 21 Jul 2006 14:22:51 GMT"/>
+
+	      <child>
+		<widget class="GtkAlignment" id="alignment4">
+		  <property name="visible">True</property>
+		  <property name="xalign">0.5</property>
+		  <property name="yalign">0.5</property>
+		  <property name="xscale">0</property>
+		  <property name="yscale">0</property>
+		  <property name="top_padding">0</property>
+		  <property name="bottom_padding">0</property>
+		  <property name="left_padding">0</property>
+		  <property name="right_padding">0</property>
+
+		  <child>
+		    <widget class="GtkHBox" id="hbox6">
+		      <property name="visible">True</property>
+		      <property name="homogeneous">False</property>
+		      <property name="spacing">2</property>
+
+		      <child>
+			<widget class="GtkImage" id="image39">
+			  <property name="visible">True</property>
+			  <property name="stock">gtk-remove</property>
+			  <property name="icon_size">4</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			</widget>
+			<packing>
+			  <property name="padding">0</property>
+			  <property name="expand">False</property>
+			  <property name="fill">False</property>
+			</packing>
+		      </child>
+
+		      <child>
+			<widget class="GtkLabel" id="label10">
+			  <property name="visible">True</property>
+			  <property name="label" translatable="yes">_Remove</property>
+			  <property name="use_underline">True</property>
+			  <property name="use_markup">False</property>
+			  <property name="justify">GTK_JUSTIFY_LEFT</property>
+			  <property name="wrap">False</property>
+			  <property name="selectable">False</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			  <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+			  <property name="width_chars">-1</property>
+			  <property name="single_line_mode">False</property>
+			  <property name="angle">0</property>
+			</widget>
+			<packing>
+			  <property name="padding">0</property>
+			  <property name="expand">False</property>
+			  <property name="fill">False</property>
+			</packing>
+		      </child>
+		    </widget>
+		  </child>
+		</widget>
+	      </child>
+	    </widget>
+	  </child>
+
+	  <child>
+	    <widget class="GtkButton" id="button_remove_cancel">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="label">gtk-cancel</property>
+	      <property name="use_stock">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_remove_cancel_clicked" last_modification_time="Fri, 21 Jul 2006 14:22:58 GMT"/>
+	    </widget>
+	  </child>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">True</property>
+	  <property name="fill">True</property>
+	</packing>
+      </child>
+    </widget>
+  </child>
+</widget>
+
+<widget class="GtkWindow" id="window_push">
+  <property name="width_request">300</property>
+  <property name="visible">True</property>
+  <property name="title" translatable="yes">Olive - Push</property>
+  <property name="type">GTK_WINDOW_TOPLEVEL</property>
+  <property name="window_position">GTK_WIN_POS_NONE</property>
+  <property name="modal">False</property>
+  <property name="resizable">True</property>
+  <property name="destroy_with_parent">False</property>
+  <property name="decorated">True</property>
+  <property name="skip_taskbar_hint">False</property>
+  <property name="skip_pager_hint">False</property>
+  <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
+  <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
+  <property name="focus_on_map">True</property>
+  <property name="urgency_hint">False</property>
+
+  <child>
+    <widget class="GtkVBox" id="vbox_push">
+      <property name="border_width">5</property>
+      <property name="visible">True</property>
+      <property name="homogeneous">False</property>
+      <property name="spacing">3</property>
+
+      <child>
+	<widget class="GtkRadioButton" id="radiobutton_push_stored">
+	  <property name="visible">True</property>
+	  <property name="can_focus">True</property>
+	  <property name="label" translatable="yes">Push to _stored location</property>
+	  <property name="use_underline">True</property>
+	  <property name="relief">GTK_RELIEF_NORMAL</property>
+	  <property name="focus_on_click">True</property>
+	  <property name="active">False</property>
+	  <property name="inconsistent">False</property>
+	  <property name="draw_indicator">True</property>
+	  <signal name="toggled" handler="on_radiobutton_push_stored_toggled" last_modification_time="Fri, 21 Jul 2006 16:39:36 GMT"/>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkRadioButton" id="radiobutton_push_specific">
+	  <property name="visible">True</property>
+	  <property name="can_focus">True</property>
+	  <property name="label" translatable="yes">Push to specific _location:</property>
+	  <property name="use_underline">True</property>
+	  <property name="relief">GTK_RELIEF_NORMAL</property>
+	  <property name="focus_on_click">True</property>
+	  <property name="active">False</property>
+	  <property name="inconsistent">False</property>
+	  <property name="draw_indicator">True</property>
+	  <property name="group">radiobutton_push_stored</property>
+	  <signal name="toggled" handler="on_radiobutton_push_specify_toggled" last_modification_time="Fri, 21 Jul 2006 16:39:41 GMT"/>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkEntry" id="entry_push_location">
+	  <property name="can_focus">True</property>
+	  <property name="editable">True</property>
+	  <property name="visibility">True</property>
+	  <property name="max_length">0</property>
+	  <property name="text" translatable="yes"></property>
+	  <property name="has_frame">True</property>
+	  <property name="invisible_char">●</property>
+	  <property name="activates_default">False</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkCheckButton" id="checkbutton_push_remember">
+	  <property name="can_focus">True</property>
+	  <property name="label" translatable="yes">_Remember this location</property>
+	  <property name="use_underline">True</property>
+	  <property name="relief">GTK_RELIEF_NORMAL</property>
+	  <property name="focus_on_click">True</property>
+	  <property name="active">False</property>
+	  <property name="inconsistent">False</property>
+	  <property name="draw_indicator">True</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkCheckButton" id="checkbutton_push_overwrite">
+	  <property name="can_focus">True</property>
+	  <property name="label" translatable="yes">_Overwrite target if diverged</property>
+	  <property name="use_underline">True</property>
+	  <property name="relief">GTK_RELIEF_NORMAL</property>
+	  <property name="focus_on_click">True</property>
+	  <property name="active">False</property>
+	  <property name="inconsistent">False</property>
+	  <property name="draw_indicator">True</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkCheckButton" id="checkbutton_push_create">
+	  <property name="can_focus">True</property>
+	  <property name="label" translatable="yes">_Create the path leading up to the location</property>
+	  <property name="use_underline">True</property>
+	  <property name="relief">GTK_RELIEF_NORMAL</property>
+	  <property name="focus_on_click">True</property>
+	  <property name="active">False</property>
+	  <property name="inconsistent">False</property>
+	  <property name="draw_indicator">True</property>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkHButtonBox" id="hbuttonbox_push">
+	  <property name="visible">True</property>
+	  <property name="layout_style">GTK_BUTTONBOX_SPREAD</property>
+	  <property name="spacing">0</property>
+
+	  <child>
+	    <widget class="GtkButton" id="button_push_push">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_push_push_clicked" last_modification_time="Fri, 21 Jul 2006 16:39:01 GMT"/>
+
+	      <child>
+		<widget class="GtkAlignment" id="alignment6">
+		  <property name="visible">True</property>
+		  <property name="xalign">0.5</property>
+		  <property name="yalign">0.5</property>
+		  <property name="xscale">0</property>
+		  <property name="yscale">0</property>
+		  <property name="top_padding">0</property>
+		  <property name="bottom_padding">0</property>
+		  <property name="left_padding">0</property>
+		  <property name="right_padding">0</property>
+
+		  <child>
+		    <widget class="GtkHBox" id="hbox8">
+		      <property name="visible">True</property>
+		      <property name="homogeneous">False</property>
+		      <property name="spacing">2</property>
+
+		      <child>
+			<widget class="GtkImage" id="image50">
+			  <property name="visible">True</property>
+			  <property name="stock">gtk-goto-top</property>
+			  <property name="icon_size">4</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			</widget>
+			<packing>
+			  <property name="padding">0</property>
+			  <property name="expand">False</property>
+			  <property name="fill">False</property>
+			</packing>
+		      </child>
+
+		      <child>
+			<widget class="GtkLabel" id="label12">
+			  <property name="visible">True</property>
+			  <property name="label" translatable="yes">_Push</property>
+			  <property name="use_underline">True</property>
+			  <property name="use_markup">False</property>
+			  <property name="justify">GTK_JUSTIFY_LEFT</property>
+			  <property name="wrap">False</property>
+			  <property name="selectable">False</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			  <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+			  <property name="width_chars">-1</property>
+			  <property name="single_line_mode">False</property>
+			  <property name="angle">0</property>
+			</widget>
+			<packing>
+			  <property name="padding">0</property>
+			  <property name="expand">False</property>
+			  <property name="fill">False</property>
+			</packing>
+		      </child>
+		    </widget>
+		  </child>
+		</widget>
+	      </child>
+	    </widget>
+	  </child>
+
+	  <child>
+	    <widget class="GtkButton" id="button_push_cancel">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="label">gtk-cancel</property>
+	      <property name="use_stock">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_push_cancel_clicked" last_modification_time="Fri, 21 Jul 2006 16:38:55 GMT"/>
+	    </widget>
+	  </child>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">True</property>
+	</packing>
+      </child>
+    </widget>
+  </child>
+</widget>
+
 </glade-interface>

=== modified file 'olive/backend/commit.py'
--- olive/backend/commit.py	2006-07-08 17:36:59 +0000
+++ olive/backend/commit.py	2006-07-21 18:18:20 +0000
@@ -32,7 +32,7 @@
            strict=False, local=False):
     """ Command to commit changes into the branch.
     
-    :param selected_list: list of files you want to commit (at least the top working directory has to specified)
+    :param selected_list: list of files you want to commit (at least the top working directory has to be specified)
     
     :param message: commit message
     
@@ -53,7 +53,7 @@
         raise NotBranchError
     
     if local and not tree.branch.get_bound_location():
-        raise LocalRequiresBoundBranch()
+        raise LocalRequiresBoundBranch
     if message is None and not file:
         if message is None:
             raise NoMessageNoFileError
@@ -100,7 +100,13 @@
     from bzrlib.branch import Branch
     from bzrlib.transport import get_transport
         
-    br_from = Branch.open_containing(branch)[0]
+    try:
+        br_from = Branch.open_containing(branch)[0]
+    except errors.NotBranchError:
+        raise NotBranchError(branch)
+    except:
+        raise
+    
     stored_loc = br_from.get_push_location()
     if location is None:
         if stored_loc is None:

=== modified file 'olive/backend/fileops.py'
--- olive/backend/fileops.py	2006-07-20 14:31:08 +0000
+++ olive/backend/fileops.py	2006-07-21 18:18:20 +0000
@@ -22,18 +22,25 @@
 
 from errors import (DirectoryAlreadyExists, MissingArgumentError,
                     MultipleMoveError, NoFilesSpecified, NoMatchingFiles,
-                    NonExistingSource, NotVersionedError)
+                    NonExistingSource, NotBranchError, NotVersionedError)
 
-def add(file_list):
+def add(file_list, recursive=False):
     """ Add listed files to the branch. 
     
     :param file_list - list of files to be added (using full paths)
     
+    :param recursive - if True, all unknown files will be added
+    
     :return: count of ignored files
     """
     import bzrlib.add
     
-    added, ignored = bzrlib.add.smart_add(file_list)
+    try:
+        added, ignored = bzrlib.add.smart_add(file_list, recursive)
+    except errors.NotBranchError:
+        raise NotBranchError
+    except:
+        raise
     
     match_len = 0
     for glob, paths in ignored.items():
@@ -86,7 +93,12 @@
     """
     from bzrlib.builtins import tree_files
     
-    tree, file_list = tree_files(file_list)
+    try:
+        tree, file_list = tree_files(file_list)
+    except errors.NotBranchError:
+        raise NotBranchError
+    except:
+        raise
     
     if new is False:
         if file_list is None:
@@ -136,7 +148,9 @@
     
     # find the relative path to the given file (needed for proper delta)
     wtpath = tree1.basedir
+    #print "DEBUG: wtpath =", wtpath
     fullpath = filename
+    #print "DEBUG: fullpath =", fullpath
     i = 0
     wtsplit = wtpath.split('/')
     fpsplit = fullpath.split('/')
@@ -147,6 +161,7 @@
                 del fpcopy[0]
             i = i + 1
     rel = '/'.join(fpcopy)
+    #print "DEBUG: rel =", rel
     
     delta = compare_trees(old_tree=tree2,
                           new_tree=tree1,
@@ -159,7 +174,7 @@
         print path
     print
     print "DEBUG: delta.added:"
-    for path, id, kind, text_modified, meta_modified in delta.added:
+    for path, id, kind in delta.added:
         print path
     print
     print "DEBUG: delta.removed:"

=== modified file 'olive/backend/init.py'
--- olive/backend/init.py	2006-07-18 22:21:00 +0000
+++ olive/backend/init.py	2006-07-21 18:18:20 +0000
@@ -29,32 +29,6 @@
                     NonExistingParent, NonExistingRevision,
                     NonExistingSource, NotBranchError, TargetAlreadyExists)
 
-def init(location):
-    """ Initialize a directory.
-    
-    :param location: full path to the directory you want to be versioned
-    """
-    from bzrlib.builtins import get_format_type
-
-    format = get_format_type('default')
- 
-    if not os.path.exists(location):
-        os.mkdir(location)
- 
-    try:
-        existing_bzrdir = bzrdir.BzrDir.open(location)
-    except errors.NotBranchError:
-        bzrdir.BzrDir.create_branch_convenience(location, format=format)
-    else:
-        if existing_bzrdir.has_branch():
-            if existing_bzrdir.has_workingtree():
-                raise AlreadyBranchError(location)
-            else:
-                raise BranchExistsWithoutWorkingTree(location)
-        else:
-            existing_bzrdir.create_branch()
-            existing_bzrdir.create_workingtree()
-
 def branch(from_location, to_location, revision=None):
     """ Create a branch from a local/remote location.
     
@@ -175,3 +149,29 @@
         checkout.create_workingtree(revision_id)
     finally:
         bzrlib.bzrdir.BzrDirFormat.set_default_format(old_format)
+
+def init(location):
+    """ Initialize a directory.
+    
+    :param location: full path to the directory you want to be versioned
+    """
+    from bzrlib.builtins import get_format_type
+
+    format = get_format_type('default')
+ 
+    if not os.path.exists(location):
+        os.mkdir(location)
+ 
+    try:
+        existing_bzrdir = bzrdir.BzrDir.open(location)
+    except errors.NotBranchError:
+        bzrdir.BzrDir.create_branch_convenience(location, format=format)
+    else:
+        if existing_bzrdir.has_branch():
+            if existing_bzrdir.has_workingtree():
+                raise AlreadyBranchError(location)
+            else:
+                raise BranchExistsWithoutWorkingTree(location)
+        else:
+            existing_bzrdir.create_branch()
+            existing_bzrdir.create_workingtree()

=== modified file 'olive/frontend/gtk/__init__.py'
--- olive/frontend/gtk/__init__.py	2006-07-20 14:31:08 +0000
+++ olive/frontend/gtk/__init__.py	2006-07-21 18:18:20 +0000
@@ -36,7 +36,7 @@
 
 class OliveGtk:
     """ The main Olive GTK frontend class. This is called when launching the
-    program."""
+    program. """
     
     def __init__(self):
         # Load the glade file
@@ -57,9 +57,17 @@
         dic = { "on_window_main_destroy": gtk.main_quit,
                 "on_quit_activate": gtk.main_quit,
                 "on_about_activate": handler.on_about_activate,
+                "on_menuitem_add_files_activate": handler.on_menuitem_add_files_activate,
+                "on_menuitem_remove_file_activate": handler.on_menuitem_remove_file_activate,
                 "on_menuitem_file_make_directory_activate": handler.not_implemented,
+                "on_menuitem_branch_initialize_activate": handler.on_menuitem_branch_initialize_activate,
                 "on_menuitem_branch_branch_activate": handler.on_menuitem_branch_branch_activate,
-                "on_menuitem_branch_commit_activate": handler.not_implemented,
+                "on_menuitem_branch_commit_activate": handler.on_menuitem_branch_commit_activate,
+                "on_menuitem_branch_push_activate": handler.on_menuitem_branch_push_activate,
+                "on_toolbutton_update_clicked": handler.not_implemented,
+                "on_toolbutton_commit_clicked": handler.on_menuitem_branch_commit_activate,
+                "on_toolbutton_pull_clicked": handler.not_implemented,
+                "on_toolbutton_push_clicked": handler.on_menuitem_branch_push_activate,
                 "on_treeview_right_row_activated": handler.on_treeview_right_row_activated }
         
         # Connect the signals to the handlers
@@ -144,6 +152,16 @@
     def get_path(self):
         """ Get the current path. """
         return self._path
+    
+    def get_selected_right(self):
+        """ Get the selected filename. """
+        treeselection = self.treeview_right.get_selection()
+        (model, iter) = treeselection.get_selected()
+        
+        if iter is None:
+            return None
+        else:
+            return model.get_value(iter, 1)
 
     def set_statusbar(self, message):
         """ Set the statusbar message. """

=== added file 'olive/frontend/gtk/add.py'
--- olive/frontend/gtk/add.py	1970-01-01 00:00:00 +0000
+++ olive/frontend/gtk/add.py	2006-07-21 18:18:20 +0000
@@ -0,0 +1,96 @@
+# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import sys
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+try:
+    import gtk
+    import gtk.glade
+except:
+    sys.exit(1)
+
+import olive.backend.errors as errors
+import olive.backend.fileops as fileops
+
+class OliveAdd:
+    """ Display the Add file(s) dialog and perform the needed actions. """
+    def __init__(self, gladefile, comm):
+        """ Initialize the Add file(s) dialog. """
+        self.gladefile = gladefile
+        self.glade = gtk.glade.XML(self.gladefile, 'window_add')
+        
+        self.comm = comm
+        
+        self.window = self.glade.get_widget('window_add')
+        
+        # Dictionary for signal_autoconnect
+        dic = { "on_button_add_add_clicked": self.add,
+                "on_button_add_cancel_clicked": self.close }
+        
+        # Connect the signals to the handlers
+        self.glade.signal_autoconnect(dic)
+
+    def display(self):
+        """ Display the Add file(s) dialog. """
+        self.window.show_all()
+        
+    def add(self, widget):
+        from dialog import OliveDialog
+        dialog = OliveDialog(self.gladefile)
+        
+        radio_selected = self.glade.get_widget('radiobutton_add_selected')
+        radio_unknown = self.glade.get_widget('radiobutton_add_unknown')
+        
+        directory = self.comm.get_path()
+        
+        if radio_selected.get_active():
+            # Add only the selected file
+            filename = self.comm.get_selected_right()
+            
+            if filename is None:
+                dialog.error_dialog('No file was selected.')
+                return
+            
+            try:
+                fileops.add([directory + '/' + filename])
+            except errors.NotBranchError:
+                dialog.error_dialog('The directory is not a branch.')
+                return
+            except:
+                raise
+        elif radio_unknown.get_active():
+            # Add unknown files recursively
+            try:
+                fileops.add([directory], True)
+            except errors.NotBranchError:
+                dialog.error_dialog('The directory is not a branch.')
+                return
+            except:
+                raise
+        else:
+            # This should really never happen.
+            pass
+        
+        self.close()
+        self.comm.refresh_right()
+    
+    def close(self, widget=None):
+        self.window.destroy()

=== added file 'olive/frontend/gtk/commit.py'
--- olive/frontend/gtk/commit.py	1970-01-01 00:00:00 +0000
+++ olive/frontend/gtk/commit.py	2006-07-21 18:18:20 +0000
@@ -0,0 +1,101 @@
+# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import sys
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+try:
+    import gtk
+    import gtk.glade
+except:
+    sys.exit(1)
+
+import olive.backend.commit as commit
+import olive.backend.errors as errors
+
+class OliveCommit:
+    """ Display Commit dialog and perform the needed actions. """
+    def __init__(self, gladefile, comm):
+        """ Initialize the Commit dialog. """
+        self.gladefile = gladefile
+        self.glade = gtk.glade.XML(self.gladefile, 'window_commit')
+        
+        self.comm = comm
+        
+        self.window = self.glade.get_widget('window_commit')
+        
+        # Dictionary for signal_autoconnect
+        dic = { "on_button_commit_commit_clicked": self.commit,
+                "on_button_commit_cancel_clicked": self.close }
+        
+        # Connect the signals to the handlers
+        self.glade.signal_autoconnect(dic)
+    
+    def display(self):
+        """ Display the Push dialog. """
+        self.window.show_all()
+    
+    def commit(self, widget):
+        from dialog import OliveDialog
+        dialog = OliveDialog(self.gladefile)
+        
+        textview = self.glade.get_widget('textview_commit')
+        textbuffer = textview.get_buffer()
+        start, end = textbuffer.get_bounds()
+        message = textbuffer.get_text(start, end)
+        
+        checkbutton_local = self.glade.get_widget('checkbutton_commit_local')
+        checkbutton_strict = self.glade.get_widget('checkbutton_commit_strict')
+        checkbutton_force = self.glade.get_widget('checkbutton_commit_force')
+        
+        try:
+            commit.commit([self.comm.get_path()], message, None,
+                          checkbutton_force.get_active(),
+                          checkbutton_strict.get_active(),
+                          checkbutton_local.get_active())
+        except errors.NotBranchError:
+            dialog.error_dialog('Directory is not a branch.')
+            return
+        except errors.LocalRequiresBoundBranch:
+            dialog.error_dialog('Local commit requires a bound branch.')
+            return
+        except errors.EmptyMessageError:
+            dialog.error_dialog('Commit message is empty.')
+            return
+        except errors.NoChangesToCommitError:
+            dialog.error_dialog('No changes to commit. Try force commit.')
+            return
+        except errors.ConflictsInTreeError:
+            dialog.error_dialog('Conflicts in tree. Please resolve them first.')
+            return
+        except errors.StrictCommitError:
+            dialog.error_dialog('Strict commit failed. There are unknown files.')
+            return
+        except errors.BoundBranchOutOfDate, errmsg:
+            dialog.error_dialog('Bound branch is out of date: %s' % errmsg)
+            return
+        except:
+            raise
+        
+        self.close()
+        self.comm.refresh_right()
+        
+    def close(self, widget=None):
+        self.window.destroy()

=== modified file 'olive/frontend/gtk/dialog.py'
--- olive/frontend/gtk/dialog.py	2006-07-17 20:24:24 +0000
+++ olive/frontend/gtk/dialog.py	2006-07-21 18:18:20 +0000
@@ -75,3 +75,11 @@
     def error_dialog(self, message):
         """ Display an error dialog with the given message. """
         self._message_dialog('error', message)
+    
+    def info_dialog(self, message):
+        """ Display an info dialog with the given message. """
+        self._message_dialog('info', message)
+    
+    def warning_dialog(self, message):
+        """ Display a warning dialog with the given message. """
+        self._message_dialog('warning', message)

=== modified file 'olive/frontend/gtk/handler.py'
--- olive/frontend/gtk/handler.py	2006-07-20 14:31:08 +0000
+++ olive/frontend/gtk/handler.py	2006-07-21 18:18:20 +0000
@@ -27,8 +27,14 @@
 except:
     sys.exit(1)
 
+import olive.backend.errors as errors
+
+from add import OliveAdd
 from branch import OliveBranch
+from commit import OliveCommit
 from dialog import OliveDialog
+from push import OlivePush
+from remove import OliveRemove
 
 class OliveHandler:
     """ Signal handler class for Olive. """
@@ -41,19 +47,51 @@
     def on_about_activate(self, widget):
         self.dialog.about()
         
+    def on_menuitem_add_files_activate(self, widget):
+        """ Add file(s)... menu handler. """
+        add = OliveAdd(self.gladefile, self.comm)
+        add.display()
+    
     def on_menuitem_branch_branch_activate(self, widget):
         """ Branch/Branch... menu handler. """
         branch = OliveBranch(self.gladefile, self.comm)
         branch.display()
-        
+    
+    def on_menuitem_branch_commit_activate(self, widget):
+        """ Branch/Commit... menu handler. """
+        commit = OliveCommit(self.gladefile, self.comm)
+        commit.display()
+    
+    def on_menuitem_branch_push_activate(self, widget):
+        """ Branch/Push... menu handler. """
+        push = OlivePush(self.gladefile, self.comm)
+        push.display()
+    
+    def on_menuitem_branch_initialize_activate(self, widget):
+        """ Initialize current directory. """
+        import olive.backend.init as init
+        
+        try:
+            init.init(self.comm.get_path())
+        except errors.AlreadyBranchError, errmsg:
+            self.dialog.error_dialog('Directory is already a branch: %s' % errmsg)
+        except errors.BranchExistsWithoutWorkingTree, errmsg:
+            self.dialog.error_dialog('Branch exists without a working tree: %s' % errmsg)
+        else:
+            self.dialog.info_dialog('Directory successfully initialized.')
+            self.comm.refresh_right()
+        
+    def on_menuitem_remove_file_activate(self, widget):
+        """ Remove (unversion) selected file. """
+        remove = OliveRemove(self.gladefile, self.comm)
+        remove.display()
+    
     def on_treeview_right_row_activated(self, treeview, path, view_column):
         """ Occurs when somebody double-clicks or enters an item in the
         file list. """
         import os.path
         
-        treeselection = treeview.get_selection()
-        (model, iter) = treeselection.get_selected()
-        newdir = model.get_value(iter, 1)
+        newdir = self.comm.get_selected_right()
         
         if newdir == '..':
             self.comm.set_path(os.path.split(self.comm.get_path())[0])

=== added file 'olive/frontend/gtk/push.py'
--- olive/frontend/gtk/push.py	1970-01-01 00:00:00 +0000
+++ olive/frontend/gtk/push.py	2006-07-21 18:18:20 +0000
@@ -0,0 +1,147 @@
+# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import sys
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+try:
+    import gtk
+    import gtk.glade
+except:
+    sys.exit(1)
+
+import olive.backend.commit as commit
+import olive.backend.errors as errors
+
+class OlivePush:
+    """ Display Push dialog and perform the needed actions. """
+    def __init__(self, gladefile, comm):
+        """ Initialize the Push dialog. """
+        self.gladefile = gladefile
+        self.glade = gtk.glade.XML(self.gladefile, 'window_push')
+        
+        self.comm = comm
+        
+        self.window = self.glade.get_widget('window_push')
+        
+        # Dictionary for signal_autoconnect
+        dic = { "on_button_push_push_clicked": self.push,
+                "on_button_push_cancel_clicked": self.close,
+                "on_radiobutton_push_stored_toggled": self.stored_toggled,
+                "on_radiobutton_push_specific_toggled": self.specific_toggled, }
+        
+        # Connect the signals to the handlers
+        self.glade.signal_autoconnect(dic)
+        
+        # Get some useful widgets
+        self.entry_location = self.glade.get_widget('entry_push_location')
+        self.check_remember = self.glade.get_widget('checkbutton_push_remember')
+        self.check_overwrite = self.glade.get_widget('checkbutton_push_overwrite')
+        self.check_create = self.glade.get_widget('checkbutton_push_create')
+    
+    def display(self):
+        """ Display the Push dialog. """
+        self.window.show()
+    
+    def stored_toggled(self, widget):
+        if widget.get_active():
+            self.entry_location.hide()
+            self.check_remember.hide()
+            self.check_overwrite.hide()
+            self.check_create.hide()
+        else:
+            self.entry_location.show()
+            self.check_remember.show()
+            self.check_overwrite.show()
+            self.check_create.show()
+    
+    def specific_toggled(self, widget):
+        if widget.get_active():
+            self.entry_location.show()
+            self.check_remember.show()
+            self.check_overwrite.show()
+            self.check_create.show()
+        else:
+            self.entry_location.hide()
+            self.check_remember.hide()
+            self.check_overwrite.hide()
+            self.check_create.hide()
+    
+    def push(self, widget):
+        import bzrlib.ui as ui
+        from olive.backend.ui import GtkUIFactory
+        ui.ui_factory = GtkUIFactory()
+        
+        from dialog import OliveDialog
+        dialog = OliveDialog(self.gladefile)
+        
+        radio_stored = self.glade.get_widget('radiobutton_push_stored')
+        radio_specific = self.glade.get_widget('radiobutton_push_specific')
+        
+        if radio_stored.get_active():
+            try:
+                commit.push(self.comm.get_path())
+            except errors.NotBranchError:
+                dialog.error_dialog('Directory is not a branch.')
+                return
+            except errors.NoLocationKnown:
+                dialog.error_dialog('No location known.')
+                return
+            except errors.NonExistingParent, errmsg:
+                dialog.error_dialog('Parent directory doesn\'t exist: %s', errmsg)
+                return
+            except errors.DivergedBranchesError:
+                dialog.error_dialog('Branches have been diverged.')
+                return
+            except:
+                raise
+        elif radio_specific.get_active():
+            location = self.entry_location.get_text()
+            if location == '':
+                dialog.error_dialog('No location specified.')
+                return
+            
+            try:
+                commit.push(self.comm.get_path(), location,
+                            self.check_remember.get_active(),
+                            self.check_overwrite.get_active(),
+                            self.check_create.get_active())
+            except errors.NotBranchError:
+                dialog.error_dialog('Directory is not a branch.')
+                return
+            except errors.NonExistingParent, errmsg:
+                dialog.error_dialog('Parent directory doesn\'t exist: %s', errmsg)
+                return
+            except errors.DivergedBranchesError:
+                dialog.error_dialog('Branches have been diverged.')
+                return
+            except errors.PathPrefixNotCreated:
+                dialog.error_dialog('Path prefix couldn\'t be created.')
+                return
+            except:
+                raise
+        else:
+            # This should really never happen
+            pass
+        
+        self.close()
+    
+    def close(self, widget=None):
+        self.window.destroy()

=== added file 'olive/frontend/gtk/remove.py'
--- olive/frontend/gtk/remove.py	1970-01-01 00:00:00 +0000
+++ olive/frontend/gtk/remove.py	2006-07-21 18:18:20 +0000
@@ -0,0 +1,101 @@
+# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import sys
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+try:
+    import gtk
+    import gtk.glade
+except:
+    sys.exit(1)
+
+import olive.backend.errors as errors
+import olive.backend.fileops as fileops
+
+class OliveRemove:
+    """ Display the Remove file(s) dialog and perform the needed actions. """
+    def __init__(self, gladefile, comm):
+        """ Initialize the Remove file(s) dialog. """
+        self.gladefile = gladefile
+        self.glade = gtk.glade.XML(self.gladefile, 'window_remove')
+        
+        self.comm = comm
+        
+        self.window = self.glade.get_widget('window_remove')
+        
+        # Dictionary for signal_autoconnect
+        dic = { "on_button_remove_remove_clicked": self.remove,
+                "on_button_remove_cancel_clicked": self.close }
+        
+        # Connect the signals to the handlers
+        self.glade.signal_autoconnect(dic)
+
+    def display(self):
+        """ Display the Add file(s) dialog. """
+        self.window.show_all()
+        
+    def remove(self, widget):
+        from dialog import OliveDialog
+        dialog = OliveDialog(self.gladefile)
+        
+        radio_selected = self.glade.get_widget('radiobutton_remove_selected')
+        radio_new = self.glade.get_widget('radiobutton_remove_new')
+        
+        directory = self.comm.get_path()
+        
+        if radio_selected.get_active():
+            # Add only the selected file
+            filename = self.comm.get_selected_right()
+            
+            if filename is None:
+                dialog.error_dialog('No file was selected.')
+                return
+            
+            try:
+                fileops.remove([directory + '/' + filename])
+            except errors.NotBranchError:
+                dialog.error_dialog('The directory is not a branch.')
+                return
+            except errors.NotVersionedError:
+                dialog.error_dialog('Selected file is not versioned.')
+                return
+            except:
+                raise
+        elif radio_new.get_active():
+            # Add unknown files recursively
+            try:
+                fileops.remove([directory], True)
+            except errors.NotBranchError:
+                dialog.error_dialog('The directory is not a branch.')
+                return
+            except errors.NoMatchingFiles:
+                dialog.warning_dialog('No matching files were found.')
+            except:
+                raise
+        else:
+            # This should really never happen.
+            pass
+        
+        self.close()
+        self.comm.refresh_right()
+    
+    def close(self, widget=None):
+        self.window.destroy()

